﻿using log4net.Core;
using Prism.Events;
using Prism.Ioc;
using Prism.Mvvm;
using Prism.Regions;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Reflection;
using System.Reflection.Emit;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Media3D;
using Toolkit.Core;
using Toolkit.Event;
using Toolkit.Log4;
using Toolkit.Tcp;
using TouchSocket.Core;
using TouchSocket.Sockets;

namespace Toolkit.ViewMode
{
    public class MainWindowViewMode : BindableBase
    {
        private BgCommunicate bgCommunicate;
        private ClientCommunicate clientCommunicate;
        EventAggregator _eventAggregator;
        private Management mana_gement;
        private  string _Errstr="";
        private SolidColorBrush _rushes= Brushes.Red;
        private int SengState=0;
        private int errCount=0;
        private Stepenum stepenum= Stepenum.RecvPD;
        public string Errstr { get => _Errstr; set { SetProperty(ref _Errstr, value); } }
        public SolidColorBrush Rushes { get => _rushes; set { SetProperty(ref _rushes, value); } }

        public MainWindowViewMode(IRegionManager regionManager, EventAggregator eventAggregator, IContainerProvider container)
        {



            mana_gement = container.Resolve<Management>();
            //string ss=";ver:1.0;packinfo:1/1;tasktype:821;positions:F;dep_name:广州分行1;taskstatus:0;datetime:2025-06-25;phone:12345678901;deal_name:gan0001;recv_date:2025-06-27;suminfo:[amount<500>currcycode<CNY>];client_name:gan0011;items:[amount<500>currcycode<CNY>itdetail<100|5>];seqid:c47367c30df7485d89ca2923b33128a2;taskid:242ad029597a483f989a64f74caffe4a;tasknum:062500011;totalpack:1;packno:1;";
            //string datsssa = mana_gement.MsgSplit(ss);

            clientCommunicate = new ClientCommunicate();
            clientCommunicate.ConnectedEvent += ClientCommunicate_ConnectedEvent;
            clientCommunicate.ReceivedEvent += ClientCommunicate_ReceivedEvent;
            clientCommunicate.DisconnectedEvent += ClientCommunicate_DisconnectedEvent;
            clientCommunicate.ConnectAsync();
            _eventAggregator = eventAggregator;


        }
        private void ClientCommunicate_DisconnectedEvent(Guid arg1, object arg2, DisconnectEventArgs arg3)
        {
            _Errstr = "打印机断开";
            Rushes = Brushes.Red;
            LogHelper.Info("打印机断开！");

            if ( bgCommunicate != null ) bgCommunicate.Dispose();
        }

        private async void ClientCommunicate_ReceivedEvent(Guid arg1, object arg2, ReceivedDataEventArgs e)
        {
            try
            {
                string msg=Encoding.UTF8.GetString(e.ByteBlock.Buffer, 0, e.ByteBlock.Len);
               // e.ByteBlock.Clear();
                LogHelper.Info("打印机返回消息：" + msg);
                await ReceivedForPrint(msg);
            }
            catch ( Exception ex )
            {
                LogHelper.error.Error(ex.ToString());
            }

        }

        private void ClientCommunicate_ConnectedEvent(Guid arg1, object arg2, ConnectedEventArgs arg3)
        {
            ITcpClient socketClient = arg2 as ITcpClient;
            LogHelper.Info($"[{socketClient.IP}]已连接打印机！");
            bgCommunicate = new BgCommunicate();
            bgCommunicate.ConnectedEvent += BgCommunicate_ConnectedEvent;
            bgCommunicate.ReceivedEvent += BgCommunicate_ReceivedEvent;
            bgCommunicate.StartListening();
            Rushes = Brushes.Green;
        }

        private void BgCommunicate_ReceivedEvent(SocketClient arg1, string arg2)
        {
            LogHelper.Info("收到PLC数据" + arg2);
            Errstr = "";
            SendMsgToPrint(arg2);
        }

        private void BgCommunicate_ConnectedEvent(TouchSocket.Sockets.SocketClient arg1, TouchSocket.Sockets.ConnectedEventArgs arg2)
        {

            LogHelper.Info($"[{arg1.ServicePort}][{arg1.IP}]已连接!");
        }

        private async void SendMsgToPrint(string msg)
        {
            
            if ( msg != "GetMessage" )
            {
              stepenum = Stepenum.RecvPD;
              await   SendMsgToPrintData(msg);
            }
            else
            {
              await  SendMsgToGetPrintState();
            }
        }

        private async Task SendMsgToPrintData(string msg)
        {
            try
            {
                if ( stepenum == Stepenum.RecvPD )
                {
                    string data= mana_gement.MsgSplit(msg);
                    if ( data != "Err" )
                    {
                        LogHelper.Info("发送Outdata");
                        clientCommunicate.Send("outdata");
                        LogHelper.Info("发送Outdata");
                        byte []res=mana_gement.GetData(data);
                        LogHelper.Info("发送数据" + data);
                        clientCommunicate.Send(res);
                        LogHelper.Info("发送数据完成");
                        stepenum = Stepenum.SendData;
                    }
                }
            }
            catch ( Exception ex )
            {
               
                LogHelper.error.Error("发送打印机消息错误：Data", ex);

            }
        }

        private async Task SendMsgToGetPrintState(bool isrun=true)
        {
            try
            {
                if ( isrun )
                {
                    LogHelper.Info("fun22");
                    clientCommunicate.Send("fun");
                    clientCommunicate.Send("22");
                    LogHelper.Info("fun22完成");
                }
                LogHelper.Info("fun25");
                clientCommunicate.Send("fun");
                clientCommunicate.Send("25");
                LogHelper.Info("fun25完成");
            }
            catch ( Exception ex )
            {
               

                LogHelper.error.Error("发送打印机消息错误：fun", ex);

            }
        }
       
        private async Task ReceivedForPrint(string msg)
        {
            try
            {

                switch ( msg )
                {
                    case "*T#":
                        LogHelper.Info("打印机返回消息：已收到数据");
                        if(stepenum== Stepenum.SendData)
                        stepenum = Stepenum.RecvTD;
                        break;
                    case "*P#":
                        LogHelper.Info("打印机返回消息：已打印数据");
                        if ( stepenum == Stepenum.RecvTD )
                        {
                            stepenum = Stepenum.RecvPD;
                            await SendMsgToGetPrintState(false);
                            errCount = 0;
                        }
                        else 
                        {
                            if ( stepenum == Stepenum.SendData )
                            {
                                if ( errCount < 3 )
                                {
                                    stepenum = Stepenum.RecvPD;
                                    await SendMsgToGetPrintState(false);
                                }
                                errCount++;
                                
                            }
                        }
                        break;
                    case "*M#":
                        Errstr = "打印机返回消息：数据宽度超出";
                        LogHelper.Info("打印机返回消息：数据宽度超出");
                        break;
                    case "*F#":
                        Errstr = "打印机返回消息：发送数据失败";
                        LogHelper.Info("打印机返回消息：发送数据失败");
                        break;
                    case "*W#":
                        Errstr = "打印机返回消息：故障";
                        LogHelper.Info("打印机返回消息：故障");
                        break;
                    case "*L#":
                        Errstr = "打印机返回消息：超出设定段数";
                        LogHelper.Info("打印机返回消息：超出设定段数");
                        break;

                    default:
                        if ( msg.Contains("OKhp") )
                        {
                            LogHelper.Info("打印机返回消息：OKhp");
                            if ( msg.Contains("fun") )
                            {
                                msg.Remove(0, msg.IndexOf("OKhp"));
                            }
                            string []strs=msg.Split(',');
                            PlcMsg plcMsg = new PlcMsg();
                            if ( strs[ 4 ] == "0" )
                            {
                                plcMsg.printer = "0";
                            }
                            else
                            {
                                plcMsg.printer = "1";
                            }
                            if ( strs[ 5 ] == "0" )
                            {
                                plcMsg.printer = "1";
                            }
                            else
                            {
                                plcMsg.printer = "0";
                            }

                            int ribbon=Convert.ToInt32(strs[ 29 ]);
                            if ( ribbon > 30 )
                            {
                                plcMsg.ribbon = "0";
                            }
                            if ( ribbon < 30 )
                            {
                                plcMsg.ribbon = "0";
                            }

                            if ( ribbon <= 1 )
                            {
                                plcMsg.ribbon = "2";
                            }

                            Type personType = plcMsg.GetType();

                            PropertyInfo[] properties = plcMsg.GetType().GetProperties();

                            StringBuilder builder= new StringBuilder();
                            for ( int j = 0; j < properties.Length - 1; j++ )
                            {
                                builder.Append(properties[ j ].Name + ":" + properties[ j ].GetValue(plcMsg) + ",");
                            }
                            builder.Append(properties[ properties.Length - 1 ].Name + ":" + properties[ properties.Length - 1 ].GetValue(plcMsg));

                            string sss=builder.ToString();
                            LogHelper.Info("发送给Plc："+sss);
                            bgCommunicate.Send(builder.ToString());
                            break;
                        }
                        break;
                }
            }
            catch ( Exception ex )
            {

               
                LogHelper.error.Error("解析打印机消息错误", ex);

            }
        }



    }
}
